:root {
  --background-color: white;
  --secondary-background-color: rgb(32, 32, 32);
  --accent-color: #3366cc;

  --code-background-color: #2b303b;
  --element-color: #bf616a;
  --attribute-color: #d08770;
  --string-color: #a3be8c;
  --comment-color: #65737e;

  --content-max-width: 700px;

  --title-font-size: 26px;
  --h1-font-size: 36px;
  --h2-font-size: 22px;
  --h3-font-size: 16px;
  --text-font-size: 16px;
  --triptych-font-size: 18px;
  --code-font-size: 14px;

  scrollbar-gutter: stable;
}

body {
  background-color: var(--background-color);
  position: relative;
  font-family: 'Open Sans';
  font-size: var(--text-font-size);
  line-height: 1.4;
  margin: 0 0 1rem 0;
}

.content {
  padding: 0 .5rem;
  max-width: var(--content-max-width);
  margin: 0 auto;
}

main {
  padding: 0 .5rem;
  max-width: var(--content-max-width);
  margin: 1rem auto;
}

section:has(h2) {
  --section-sep: 1rem;
  margin: var(--section-sep) 0;
  padding-bottom: var(--section-sep);
  /* border-bottom: 5px dotted black; */
}

a, a:visited {
  color: black;
}

a:hover, a:visited:hover {
  color: var(--attribute-color);
}

h1 {
  font-size: var(--h1-font-size);
  /* font-weight: normal; */
}

h2 {
  font-size: var(--h2-font-size);
}

h3, p.answer {
  font-weight: bold;
  font-size: var(--h3-font-size);
}

.key-details {
  margin-top: 1rem 0;
}

section.example {
  margin-top: 2rem;
  margin-bottom: 1rem;
}

section.q-a {
  margin-bottom: 2rem;
}

section.q-a:last-child {
  margin-bottom: 0;
}

dl {
  display: grid;
  grid-template-columns: fit-content(40%) 1fr;
  row-gap: .25rem;
  column-gap: 1rem;
  margin: .5rem;

  dd {
    margin: 0;
  }
}

header {
  background-color: var(--secondary-background-color);
  padding: 1rem;
  color: whitesmoke;
  a, a:visited { color: white; }

  .content {
    display: flex;
    justify-content: space-between;
    align-items: center;
    flex-wrap: wrap;
  }

  .site-title {
    display: inline-block;
    font-size: var(--title-font-size);
    /* font-weight: bold; */

  }

  a {
    text-decoration: none;
  }

  ul {
    display: inline-flex;
    list-style: none;
    padding: 0;
    margin: 1rem 0;

    li {
      margin-right: 2rem;
    }
  }

  border-bottom: 2px solid black;
}

a, a:visited {
  color: black;
}


.emphasis-links {
  margin: 2rem 0;
  display: block;
  width: fit-content;
  font-size: var(--triptych-font-size);

  li {
    margin: 1rem 0;
    text-underline-offset: 3px;
    font-weight: bold;
  }
}

.jump-list {
  span {
    margin-right: 1rem;
  }

  ul {
    display: inline-flex;
    flex-direction: row;
    list-style: none;
    margin: 0;
    padding: 0;

    li {
      margin: 0;
      margin-right: 1rem;
    }
  }

  a, a:visited { color: black; }
}

.hero {
  background-color: var(--secondary-background-color);
  padding: 1rem;
  color: white;
}

time {
  font-style: italic;
}

code, pre.code {
  font-family: 'Berkeley Mono';
}

.code .element {
  color: var(--element-color);
}

.code .attribute {
  color: var(--attribute-color);
}

.code .string {
  color: var(--string-color);
}

.code .comment {
  color: var(--comment-color);
}

pre.code {
  display: block;
  box-sizing: border-box;
  width: 100%;
  border-radius: 0.25rem 0.25rem;
  font-size: var(--code-font-size);
  letter-spacing: .05rem;
  margin-top: 0;
  top: -1rem;
  right: .5rem;
  content: attr(data-name);
  background-color: var(--secondary-background-color);
  color: #c0c5ce;
  visibility: visible;
  padding: 1rem;
  overflow-x: auto;
}

pre[data-linenos] {
  padding: 1rem 0;
}

@font-face {
  font-family: 'Open Sans';
  src: url('./fonts/open-sans/OpenSans-Regular.woff2') format('truetype');
  font-style: normal;
  font-weight: normal;
  font-stretch: normal;
  font-display: normal;
}

@font-face {
  font-family: 'Open Sans';
  src: url('./fonts/open-sans/OpenSans-Italic.woff2') format('truetype');
  font-style: italic;
  font-weight: normal;
  font-stretch: normal;
  font-display: normal;
}

@font-face {
  font-family: 'Open Sans';
  src: url('./fonts/open-sans/OpenSans-Bold.woff2') format('truetype');
  font-style: normal;
  font-weight: bold;
  font-stretch: normal;
  font-display: normal;
}

@font-face {
  font-family: 'Open Sans';
  src: url('./fonts/open-sans/OpenSans-BoldItalic.woff2') format('truetype');
  font-style: italic;
  font-weight: bold;
  font-stretch: normal;
  font-display: normal;
}


@font-face {
  font-family: 'Berkeley Mono';
  font-style: normal;
  font-weight: normal;
  font-stretch: normal;
  font-display: auto;
  src: url('/fonts/berkeley-mono/BerkeleyMono-Regular.woff2') format('woff2');
}

@font-face {
  font-family: 'Berkeley Mono';
  font-style: normal;
  font-weight: bold;
  font-stretch: normal;
  font-display: auto;
  src: url('/fonts/berkeley-mono/BerkeleyMono-Bold.woff2') format('woff2');
}

@font-face {
  font-family: 'Berkeley Mono';
  font-style: italic;
  font-weight: normal;
  font-stretch: normal;
  font-display: auto;
  src: url('/fonts/berkeley-mono/BerkeleyMono-Oblique.woff2') format('woff2');
}

@font-face {
  font-family: 'Berkeley Mono';
  font-style: italic;
  font-weight: bold;
  font-stretch: normal;
  font-display: auto;
  src: url('/fonts/berkeley-mono/BerkeleyMono-Bold-Oblique.woff2') format('woff2');
}
